<?php
// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// | Theme switch plugin                                                   |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2012      Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2010      Pavel Budka               http://budkovi.ic.cz |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

function theme_controler_switch()
{
  global $user, $template, $conf;
  
  $same = $user['theme'];
  if ( isset( $_GET['theme']) ) 
  {
    if ( !empty($_GET['theme']) and file_exists(PHPWG_THEMES_PATH.$_GET['theme']) )
    {
      if ( is_a_guest() or is_generic() )
      {
        pwg_set_session_var('theme_switch', $_GET['theme']);
      }
      else
      {
        $query = '
UPDATE '.USER_INFOS_TABLE.'
  SET theme = "'.$_GET['theme'].'"
  WHERE user_id = '.$user['id'].'
;';
        pwg_query($query);
      }
      $user['theme'] = $_GET['theme'];
    }
  }
  else if ( (is_a_guest() or is_generic()) and pwg_get_session_var('theme_switch')!=null )
  {
    $user['theme'] = pwg_get_session_var('theme_switch');
  }
}

function theme_controler_init()
{
  global $conf;
  
  if ( isset($conf['theme_switch_mode']) and $conf['theme_switch_mode'] == 'select' )
  {
    theme_controler_select();
  }
  else
  {
    theme_controler_thumb();
  }
}

function theme_controler_thumb()
{
  global $user, $template, $conf;
  
  foreach (get_pwg_themes() as $id => $name)
  {
    $img =  PHPWG_THEMES_PATH.$id.'/screenshot.png';
         
    if (file_exists($img))
    {
      $theme = array(
        'id' => $id,
        'name' => $name,
        'url' => add_url_params( duplicate_index_url(), array('theme'=>$id) ),
        'img' => $img,
        );
        
      if ($id==$user['theme'])
      {
        $template->assign('theme_switch_active', $theme);
      }
      
      $template->append('theme_switch', $theme);
    }
  } 

  $safe_themes = array('clear','dark','elegant','Sylvia','simple-grey','simple-black','simple-white','kardon','luciano','montblancxl');
  
  $template->assign(array(
    'THEME_SWITCH_PATH' => THEME_SWITCH_PATH,
    'THEME_SWITCH_LOAD_STYLE' => !in_array($user['theme'], $safe_themes),
    ));
  
  $template->set_filename('theme_thumb', dirname(__FILE__) . '/thumb.tpl');
  $template->concat('PLUGIN_INDEX_ACTIONS', $template->parse('theme_thumb', true));
  $template->clear_assign('theme_thumb');
}

function theme_controler_select()
{
  global $user, $template;

  foreach (get_pwg_themes() as $id => $name)
  {      
    $template->append('theme_switch', array(
      'id' => $id,
      'name' => $name,
      'url' => add_url_params( duplicate_index_url(), array('theme'=>$id) ),
      'select' => ($id==$user['theme']) ? 'selected="selected"' :  null,
      ));
  }
  
  $template->set_filename('theme_select', dirname(__FILE__) . '/select.tpl');
  $template->concat('PLUGIN_INDEX_ACTIONS', $template->parse('theme_select', true));
  $template->clear_assign('theme_select');
}

?>